<?php
/** 
* 
* ARI Smart Content Anywhere Joomla! module
* Copyright (c) 2009 ARI Soft. http://www.ari-soft.com
* Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html 
* 
*/

if (!class_exists('AriSmartContentAnywhereModule'))
{
	class AriSmartContentAnywhereModule
	{
		var $_isComponentInstalled = null;

		function process($params)
		{
			global $option;

			if (!$this->_isSCInstalled()) return ;
			
			$allComponents = $params->get('allComponents', 'yes');
			if ($allComponents != 'yes')
			{
				if (empty($option)) return ;

				$components = $params->get('components', '');
				$components = str_replace('<br />', "\n", $components);
				$components = explode("\n", $components);
				$components = array_map('trim', $components);

				if (!in_array($option, $components)) return ;
			}
			
			$this->_load();
		
			$includesManager = new AriDocumentIncludesManager();
			
			$bot = new AriSmartContentMambot();
			$content = @ob_get_contents();
			@ob_clean();

			$bot->processContent(true, $content, $pParams);
	
			echo $content;

			$includes = $includesManager->getDifferences();
			AriDocumentHelper::addCustomTagsToDocument($includes);			
		}
		
		function _load()
		{
			static $loaded = false;
			if ($loaded) return ;
			
			global $mosConfig_absolute_path;
			
			require_once $mosConfig_absolute_path . '/administrator/components/com_arismartcontent/kernel/class.AriKernel.php';
			
			AriKernel::import('Joomla.JoomlaBridge');
			AriKernel::import('Constants.ClassConstants');
			AriKernel::import('Constants.ConstantsManager');
			AriKernel::import('GlobalPrefs.GlobalPrefs');
			AriKernel::import('Components.AriSmartContent.AriSmartContent');
			AriKernel::import('Components.AriSmartContent.Mambot.AriSmartContentMambot');
			AriKernel::import('Web.Utils.WebHelper');
			AriKernel::import('Web.TaskManager');
			AriKernel::import('Web.Response');
			AriKernel::import('Controllers.ControllerBase');
			AriKernel::import('Mambot.MambotBase');
			AriKernel::import('Web.JSON.JSONHelper');
			AriKernel::import('Document.DocumentHelper');
			AriKernel::import('Document.DocumentIncludesManager');
			
			$scComp =& AriSmartContentComponent::instance();
			$scComp->init();
			
			$loaded = true;
		}
		
		function _isSCInstalled()
		{
			if (is_null($this->_isComponentInstalled))
			{
				global $mosConfig_absolute_path;
				$adminBasePath = $mosConfig_absolute_path . '/administrator/components/com_arismartcontent';
			
				$this->_isComponentInstalled = @file_exists($adminBasePath); 
			}

			return $this->_isComponentInstalled; 
		}
	}
}

$scMod = new AriSmartContentAnywhereModule();
$scMod->process($params);
?>